﻿# fuelle-tiefensuche-zwei.py
# rekursives Programm zum Füllen eines Containers mit Tiefensuche


# Globale Variable für die Stücke:
stuecke=[30,30,30,30,30,20,20,20,20]
def erzeuge_Container(fassungsvermoegen):
    return [fassungsvermoegen, []]

def fuelle_ein(stueck, container):
    inhalt=[]+container[1] # echte Kopie erzeugen!
    inhalt.append(stueck)
    return [container[0], inhalt]

# Prädikat zum Testen, ob der Container voll ist.
def ist_voll(container):
    return container[0]==sum(container[1])

def alle_voll(container_1, container_2):
    if not ist_voll(container_1):
        return False
    if not ist_voll(container_2):
        return False
    return True

def ist_zu_voll(stueck, container):
    return container[0]<sum(container[1])

def fuelle(stuecke, container_1, container_2):
    ##print(str((stuecke, container_1, container_2))) ## zum Verfolgen des Ablaufs
    if alle_voll(container_1, container_2):
        return container_1, container_2
    if len(stuecke)==0:
        return False
    if ist_zu_voll(stuecke[0], container_1):
        return False
    if ist_zu_voll(stuecke[0], container_2):
        return False
    ergebnis=fuelle(stuecke[1:],
                    fuelle_ein(stuecke[0], container_1),
                    container_2)
    if ergebnis:
        return ergebnis
    ergebnis=fuelle(stuecke[1:],
                    container_1,
                    fuelle_ein(stuecke[0], container_2))
    if ergebnis:
        return ergebnis
    else:
        return fuelle(stuecke[1:], container_1, container_2)


### Tests
def ausgabe(stuecke, fassungsvermoegen):
    print('Stücke:', stuecke, fassungsvermoegen,
          'Ergebnis:\n', fuelle(stuecke,
                                [fassungsvermoegen, []],
                                [fassungsvermoegen, []]), '\n')


##ausgabe( stuecke, 80)
##ausgabe( stuecke, 90)
ausgabe( stuecke, 100)
##stuecke.reverse()
##print(stuecke)
##ausgabe( stuecke, 100)
##ausgabe( stuecke*10, 100)
##ausgabe( stuecke*10, 1000)
##ausgabe( [30,30,20,20], 50)
